Program Siemensx;

Uses Os2Base,SysUtils;

{&cdecl+}
Function ComSelectSIMBook(Var AhCom : LongInt; Const AI : LongInt) : LongInt;
  external 'siemensd' index 1;

Function ComSelectCS(Var AhCom : LongInt; Const AI : LongInt) : LongInt;
  external 'siemensd' index 2;

Function ComReadSIMRecord(Var AhCom : LongInt; Const IDX : LongInt; PBUF : Pointer; Var Len : LongInt) : LongInt;
  external 'siemensd' index 3;

Function ComWriteSIMRecord(Var AhCom : LongInt; Const IDX : LongInt; PBUF : Pointer; Const  Len : LongInt) : LongInt;
  external 'siemensd' index 4;

Function ComDeleteSIMRecord(Var AhCom : LongInt;Const  IDX : LongInt) : LongInt;
  external 'siemensd' index 5;

Function ComGetSIMBookRange(Var AhCom : LongInt;Var Min : LongInt;Var Max : LongInt) : LongInt;
  external 'siemensd' index 6;

Function ComClose(Var AhCom : LongInt) : LongInt;
  external 'siemensd' index 7;

Function ComSetParametrs(Const ComName : PChar; Baud : LongInt) : LongInt;
  external 'siemensd' index 8;

Function GetVersion : LongInt;
  external 'siemensd' index 9;

Function GetDescription : Pointer;
  external 'siemensd' index 10;

Function ComCallNumber(Var AhCom : LongInt; Const nb : PChar) : LongInt;
  external 'siemensd' index 14;

Function ComDropCall(Var AhCom : LongInt) : LongInt;
  external 'siemensd' index 15;



Function MobileQueryCopyright : PChar;
  external 'siemensd' name 'MobileQueryCopyright';

Function MobileQueryDeviceList : Pchar;
  external 'siemensd' name 'MobileQueryDeviceList';

Function MobileQueryAPI(APIFlag: Integer): Pointer;
  external 'siemensd' name 'MobileQueryAPI';

Type

  PMobileAPI_Base = ^TMobileAPI_Base;
  TMobileAPI_Base = packed record
    MobileOpen: function(PhoneName: PChar; PortName: PChar; var Handle: LongInt): LongInt;
{
    뢠 COM-  ᨬ  PortName, ࠨ  ࠬ
     ᮮ⢥⢨  મ ⥫䮭 PhoneName, 뢠  Handle 
    ᯮ  쭥 맮 䨪. 頥  訡
    ( ।ᬮ  ᮮ⢥ ⠭)
}
    MobileClose: function(var Handle: LongInt): LongInt;
{
    ᢮ ᯮ㥬 , 뢠 COM-.
    㭪 頥  訡.
}
  end;

  PMobileAPI_PhoneBook = ^TMobileAPI_PhoneBook;
  TMobileAPI_PhoneBook = packed record
    MobileSelectPhoneBook: function(var Handle: LongInt; Const AI: LongInt): LongInt;
{
    롨ࠥ    SIM   ⥫䮭.  AI । 
    . ࠧ㬥 ᫥饥 ᯮ짮 㭪樨, ⮡
    ᬮ  ,  :   ந 横  AI  0
      ,  㭪    訡 "  ".
     㬮砭 ᯮ ᭠  <<...>>
    㭪 頥  訡.
}
    MobileGetRecordsRange: function(var Handle: LongInt; var Min: LongInt; var Max: LongInt): LongInt;
{
    뢠   Min..Max ⨬  ᮢ  ⥪饩
    ᭮ . 㭪 頥  訡.
}
    MobileDeleteRecord: function(var Handle: LongInt; Const IDX: LongInt): LongInt;
{
      ⥪饩 ᭮    ஬ IDX.
    㭪 頥  訡.
}
    MobileReadRecord: function(var Handle: LongInt; Const IDX: LongInt; PBUF: Pointer; var Len: LongInt): LongInt;
    MobileWriteRecord: function(var Handle: LongInt; Const IDX: LongInt; PBUF: Pointer; Const Len: LongInt): LongInt;

    MobileCallNumber: function(var Handle: LongInt; Const Number: PChar): LongInt;
    MobileHangUp: function(var Handle: LongInt): LongInt;
    MobileCountrySelection: function(var Handle: LongInt; Const AI : LongInt): LongInt;
  end;

{&cdecl-}

function FirstWord(Var S : String;Trm : Char) : String;
var
  k : Word;
begin
  k:=Pos(Trm,S);
  if k > 0 then
    begin
      FirstWord:=Copy(S,1,k-1);
      Delete(S,1,k);
    end
    else
    begin
      FirstWord:=S;
      S:='';
    end;
end;

Var
  MyCom: LongInt;
  i,rc : LongInt;
  j,m  : LongInt;
  S,FW : String;
  po   : array[0..1024] of byte;
  xp   : PChar;
  Len  : LongInt;
  P1   : PMobileAPI_Base;
  P2   : PMobileAPI_PhoneBook;
  nbBook : LongInt;

begin
  Writeln('Load ',MobileQueryCopyright);
  Writeln('Support Models:');
  xp:=MobileQueryDeviceList;
  While StrLen(xp) > 0 do
    begin
      Writeln(xp);
      xp:=xp+StrLen(xp)+1;
    end;
  P1:=MobileQueryAPI(1);
  P2:=MobileQueryAPI(2);
  MyCom:=-1;
  nbBook:=2;
  for i:=1 to 2 do
    begin
      S:=ParamStr(i);
      if (Length(S) > 1) and (S[1] = '/') then
        Case S[2] of
        'A','a' : begin
                    Delete(S,1,3);
                    P2^.MobileSelectPhoneBook(MyCom,nbBook);
                    P2^.MobileCountrySelection(MyCom,2);
                    FW:=FirstWord(S,',')+#00;
                    StrCopy(@po[0],@FW[1]);
                    j:=StrLen(@po[0])+1;
                    for m:=1 to Length(S) do
                      if S[m] = '_' then S[m]:=' ';
                    S:=S+#00;
                    StrCopy(@po[j],@S[1]);
                    P2^.MobileWriteRecord(MyCom,0,@po, Sizeof(po));
                    Halt(0);
                  end;
        'B','b' : begin
                    FirstWord(S,':');
                    nbBook:=StrToIntDef(S,2);
                  end;
        'C','c' : begin
                    Delete(S,1,3);
                    FW:=FirstWord(S,':')+#00;
                    ComSetParametrs(@FW[1],StrToIntDef(S,19200));
                  end;
        'D','d' : begin
                    Delete(S,1,3);
                    P2^.MobileSelectPhoneBook(MyCom,nbBook);
                    P2^.MobileCountrySelection(MyCom,2);
                    j:=StrToIntDef(S,0);
                    if j > 0 then P2^.MobileDeleteRecord(MyCom,j);
                    Halt(0);
                  end;
        'I','i' : begin
                    Delete(S,1,3);
                    Writeln('Call number ',S);
                    S:=S+#00;
                    P2^.MobileCallNumber(MyCom,@S[1]);
                    Halt(0);
                  end;
        'H','h' : begin
                    P2^.MobileHangUp(MyCom);
                    Halt(0);
                  end;
        End;
    end;
  rc:=P2^.MobileSelectPhoneBook(MyCom,nbBook);
  if rc <> 0 then
    begin
      if rc = 2 then Writeln('Trial Expire')
        else Writeln('Error rc= ',rc);
      Halt(0);
    end;
  P2^.MobileCountrySelection(MyCom,2);
  P2^.MobileGetRecordsRange(MyCom,i,m);
  Repeat
    Len:=Sizeof(po);
    rc:=P2^.MobileReadRecord(MyCom,i,@po,Len);
    if rc = 0 then
      begin
        xp:=@po;
{        if nbBook > 20 then Writeln(xp)
          else
          begin}
            Write(xp:4,'|');
            j:=StrLen(xp);
            xp:=xp+j+1;
            Write(xp:16,'|');
            j:=StrLen(xp);
            xp:=xp+j+1;
            Write(xp:40,'|');
            Writeln;
//          end;
      end
      else
      Writeln(i:4,'| <empty> rc=',rc);
    inc(i);
    if i > 50 then break;
  Until i > m;
  P1^.MobileClose(MyCom);
end.
